package cz.xelfi.quoridor.webidor;

import java.util.Date;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlValue;

/**
 *
 * @author Jaroslav Tulach <jtulach@netbeans.org>
 */
@XmlAccessorType(XmlAccessType.FIELD)
public class Note {
    @XmlValue
    private String comment;
    @XmlAttribute
    private Date when;
    @XmlAttribute
    private String who;

    private Note() {
    }

    public Note(String comment, Date when, String who) {
        this.comment = comment;
        this.when = new Date(when.getTime());
        this.who = who;
    }

    public String getComment() {
        return comment;
    }

    public Date getWhen() {
        return (Date) when.clone();
    }

    public String getWho() {
        return who;
    }

    @Override
    public String toString() {
        return "Note[" + who + "@" + when + ": " + comment + "]";
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final Note other = (Note) obj;
        if ((this.comment == null) ? (other.comment != null) : !this.comment.equals(other.comment)) {
            return false;
        }
        if (this.when != other.when && (this.when == null || !this.when.equals(other.when))) {
            return false;
        }
        if ((this.who == null) ? (other.who != null) : !this.who.equals(other.who)) {
            return false;
        }
        return true;
    }

    @Override
    public int hashCode() {
        int hash = 7;
        hash = 59 * hash + (this.comment != null ? this.comment.hashCode() : 0);
        hash = 59 * hash + (this.when != null ? this.when.hashCode() : 0);
        hash = 59 * hash + (this.who != null ? this.who.hashCode() : 0);
        return hash;
    }


}
